org.apache.bcel.classfile

## Class ConstantClass

- java.lang.Object
- - org.apache.bcel.classfile.Constant
  - - org.apache.bcel.classfile.ConstantClass

- All Implemented Interfaces:
    Cloneable, ConstantObject, Node

      public final class ConstantClass
      extends Constant
      implements ConstantObject

  This class is derived from the abstract `Constant` and represents a reference to a (external) class.
  See Also:
    `Constant`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Constant

      `tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConstantClass(ConstantClass c)` Initialize from another object.
    `ConstantClass(int nameIndex)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `void` | `dump(DataOutputStream file)` Dumps constant class to file stream in binary format.
    `String` | `getBytes(ConstantPool cp)`
    `Object` | `getConstantValue(ConstantPool cp)`
    `int` | `getNameIndex()`
    `void` | `setNameIndex(int nameIndex)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Constant

      `clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ConstantClass

          public ConstantClass(ConstantClass c)

      Initialize from another object.

    - #### ConstantClass

          public ConstantClass(int nameIndex)

      Parameters:
        `nameIndex` - Name index in constant pool. Should refer to a ConstantUtf8.

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Constant`
      Parameters:
        `v` - Visitor object

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dumps constant class to file stream in binary format.
      Specified by:
        `dump` in class `Constant`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException` - if an I/O error occurs writing to the DataOutputStream.

    - #### getNameIndex

          public int getNameIndex()

      Returns:
        Name index in constant pool of class name.

    - #### setNameIndex

          public void setNameIndex(int nameIndex)

      Parameters:
        `nameIndex` - the name index in the constant pool of this Constant Class

    - #### getConstantValue

          public Object getConstantValue(ConstantPool cp)

      Specified by:
        `getConstantValue` in interface `ConstantObject`
      Returns:
        String object

    - #### getBytes

          public String getBytes(ConstantPool cp)

      Returns:
        dereferenced string

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Constant`
      Returns:
        String representation.

Copyright © 2004–2020 The Apache Software Foundation. All rights reserved.